<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<mat-card id="testingCardsLotList" [class.read-only]="readOnly">
  <mat-card-header>
    <mat-card-title>{{ "testing-cards-lot.title" | translate }}</mat-card-title>
    <mat-card-subtitle>{{ "testing-cards-lot.subtitle.list" | translate }}</mat-card-subtitle>
  </mat-card-header>

  <mat-card-content fxLayout="column" class="no-padding">

    <div *ngIf="relatedDoi && relatedDoi.length == 0" class="parameter-input" id="cannot-create-lot">
      {{ "testing-cards-lot.no-registry" | translate }}
    </div>


    <div class="mat-card-button-toolbar"
         fxLayout fxLayoutAlign="end" fxLayoutGap="2.5rem"
         *ngIf="!readOnly && relatedDoi && relatedDoi.length > 0">

      <button mat-raised-button (click)="createNew()" color="primary" id="createNewTestingCardsLotButton"
              *roles="['CREATE_TEST_VOTING_CARD_DEFINITION']">
        <mat-icon>add</mat-icon>
        {{"testing-cards-lot.actions.create" | translate | uppercase}}
      </button>
    </div>


    <div [hidden]="elementsCount === 0">

      <mat-table #table [dataSource]="dataSource" matSort id="testingCardsLotTable">

        <!-- Column definition for field lotName -->
        <ng-container matColumnDef="lotName">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"testing-cards-lot.grid.header.lot-name" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            {{element.lotName}}
          </mat-cell>
        </ng-container>

        <!-- Column definition for field cardType -->
        <ng-container matColumnDef="cardType">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"testing-cards-lot.grid.header.card-type" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            {{element.cardType}}
          </mat-cell>
        </ng-container>

        <!-- Column definition for field count -->
        <ng-container matColumnDef="count">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"testing-cards-lot.grid.header.count" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            {{element.count}}
          </mat-cell>
        </ng-container>

        <ng-container matColumnDef="voter">
          <mat-header-cell *matHeaderCellDef>
            {{"testing-cards-lot.grid.header.voter" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            {{element.signature}} {{element.firstName}} {{element.lastName}}<br/>
            <ng-container *ngFor="let addressLine of element.address">
              {{addressLine}}<br>
            </ng-container>
          </mat-cell>
        </ng-container>

        <!-- Column definition for field language -->
        <ng-container matColumnDef="language">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"testing-cards-lot.grid.header.language" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            {{element.language}}
          </mat-cell>
        </ng-container>

        <!-- Column definition for field shouldPrint -->
        <ng-container matColumnDef="shouldPrint">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"testing-cards-lot.grid.header.should-print" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            {{element.shouldPrint}}
          </mat-cell>
        </ng-container>

        <!-- Column definition for actions -->
        <ng-container matColumnDef="actions">
          <mat-header-cell *matHeaderCellDef> {{"testing-cards-lot.grid.header.actions" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <ng-container *ngIf="!readOnly">
              <button mat-icon-button color="accent" class="btn-delete" (click)="remove(element)"
                      *roles="['DELETE_TEST_VOTING_CARD_DEFINITION']">
                <mat-icon>clear</mat-icon>
              </button>
            </ng-container>

            <button mat-icon-button class="btn-edit" (click)="edit(element)"
                    *ngIf="relatedDoi && relatedDoi.length > 0">
              <mat-icon color="primary" *ngIf="!readOnly">edit</mat-icon>
              <mat-icon color="primary" *ngIf="readOnly">search</mat-icon>
            </button>
          </mat-cell>
        </ng-container>

        <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
        <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
      </mat-table>
    </div>

  </mat-card-content>
</mat-card>
